Index: TXM/trunk/org.txm.treesearch.rcp/src/org/txm/treesearch/editor/TreeSearchEditor.java
===================================================================
--- TXM/trunk/org.txm.treesearch.rcp/src/org/txm/treesearch/editor/TreeSearchEditor.java	(revision 3554)
+++ TXM/trunk/org.txm.treesearch.rcp/src/org/txm/treesearch/editor/TreeSearchEditor.java	(revision 3555)
@@ -2,8 +2,10 @@
 
 import java.io.File;
 import java.io.IOException;
+import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.HashMap;
+import java.util.List;
 
 import org.eclipse.swt.SWT;
 import org.eclipse.swt.browser.Browser;
@@ -30,6 +32,7 @@
 import org.txm.core.results.Parameter;
 import org.txm.edition.rcp.handlers.OpenEdition;
 import org.txm.rcp.IImageKeys;
+import org.txm.rcp.editors.ITXMResultEditor;
 import org.txm.rcp.editors.TXMBrowserEditor;
 import org.txm.rcp.editors.TXMEditor;
 import org.txm.rcp.editors.TXMResultEditorInput;
@@ -219,7 +222,7 @@
 		l1.setText("T "); //$NON-NLS-1$
 		l1.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false));
 		
-		TCombo = new Combo(line2, SWT.READ_ONLY);
+		TCombo = new Combo(line2, SWT.READ_ONLY|SWT.MULTI);
 		GridData gdata = new GridData(SWT.FILL, SWT.CENTER, true, true);
 		TCombo.setLayoutData(gdata);
 		TCombo.addSelectionListener(selChangedListener);
@@ -383,7 +386,7 @@
 		String[] tFeatures = ts.getAvailableTProperties();
 		if (tFeatures.length > 0) {
 			TCombo.setItems(tFeatures);
-			TCombo.setText(ts.getT());
+			//TCombo.setText(ts.getT());
 		}
 		
 		String[] ntFeatures = ts.getAvailableNTProperties();
@@ -441,7 +444,7 @@
 		}
 		
 		if (ts.isDrawn()) {
-			sentSpinner.setSelection(1);
+			sentSpinner.setSelection(ts.getCurrentMatchIndex() + 1);
 			sentSpinner.setMaximum(ts.getNSentences());
 			// if (ts.hasSubMatchesStrategy()) {
 			subSpinner.setSelection(ts.getSub(0));
@@ -515,6 +518,7 @@
 		try {
 			TreeSearch ts = tsPerRepresentation.get(currentSelector.getEngine());
 			if (ts.getNSentences() > 0) {
+				
 				sentCounterLabel.setText("/" + ts.getNSentences()); //$NON-NLS-1$
 				if (ts.hasSubMatchesStrategy()) subCounterLabel.setText("/" + ts.getNSubGraph(0)); //$NON-NLS-1$
 				sentSpinner.setSelection(ts.getCurrentMatchIndex());
@@ -546,7 +550,12 @@
 	 */
 	private boolean reloadGraph() {
 		
-		String T = TCombo.getText();
+		List<String> T = null;
+		if (TCombo.getText().isEmpty()) {
+			T = new ArrayList<String>();
+		} else {
+			T = Arrays.asList(TCombo.getText().split(", "));
+		}
 		String NT = NTCombo.getText();
 		int sent = sentSpinner.getSelection() - 1;
 		int sub = 0;
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog.java	(revision 3554)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog.java	(revision 3555)
@@ -87,7 +87,7 @@
 	 * @param args pre-filled fields
 	 */
 	public ParametersDialog(Shell parentShell, Object bean, List<OptionHandler> allParameters, Map args, Map defaultArgs) {
-
+		
 		super(parentShell);
 		if (bean != null) {
 			this.script = bean.getClass().getName();
@@ -564,135 +564,145 @@
 	 * @return true if the user has clicked on the "OK" button
 	 */
 	public static boolean open(final Object bean) {
-		errorOpen = true;
-		retOpen = false;
 		
-		// if (!(bean instanceof groovy.lang.Script)) {
-		// System.out.println(Messages.ParametersDialog_15);
-		// return false;
-		// }
-		
-		Object oArgs = null;
-		if (bean instanceof groovy.lang.Script) {
-			groovy.lang.Script script = (groovy.lang.Script) bean;
+		try {
 			
-			// if the "args" variable exists then use its values. Can be used to set a default value by another Macro
-			if (script.getBinding().hasVariable("args")) {
-				oArgs = script.getBinding().getVariable("args"); //$NON-NLS-1$
+			errorOpen = true;
+			retOpen = false;
+			
+			// if (!(bean instanceof groovy.lang.Script)) {
+			// System.out.println(Messages.ParametersDialog_15);
+			// return false;
+			// }
+			
+			Object oArgs = null;
+			if (bean instanceof groovy.lang.Script) {
+				groovy.lang.Script script = (groovy.lang.Script) bean;
+				
+				// if the "args" variable exists then use its values. Can be used to set a default value by another Macro
+				if (script.getBinding().hasVariable("args")) {
+					oArgs = script.getBinding().getVariable("args"); //$NON-NLS-1$
+				}
 			}
-		}
-		
-		Object oDefaultArgs = null;
-		if (bean instanceof groovy.lang.Script) {
-			groovy.lang.Script script = (groovy.lang.Script) bean;
 			
-			// if the "defaultArgs" variable exists then use its values. Can be used to set a default value by another Macro
-			if (script.getBinding().hasVariable("defaultArgs")) {
-				oDefaultArgs = script.getBinding().getVariable("defaultArgs"); //$NON-NLS-1$
+			Object oDefaultArgs = null;
+			if (bean instanceof groovy.lang.Script) {
+				groovy.lang.Script script = (groovy.lang.Script) bean;
+				
+				// if the "defaultArgs" variable exists then use its values. Can be used to set a default value by another Macro
+				if (script.getBinding().hasVariable("defaultArgs")) {
+					oDefaultArgs = script.getBinding().getVariable("defaultArgs"); //$NON-NLS-1$
+				}
 			}
-		}
-		
-		final Map args;
-		if (oArgs == null || !(oArgs instanceof Map)) {
-			args = new HashMap<String, Object>();
-		}
-		else {
-			args = (Map) oArgs;
-		}
-		
-		if (bean instanceof groovy.lang.Script) { // create the args binding if not already existing
-			groovy.lang.Script script = (groovy.lang.Script) bean;
-			if (!script.getBinding().hasVariable("args")) {
-				script.getBinding().setVariable("args", args);
+			
+			final Map args;
+			if (oArgs == null || !(oArgs instanceof Map)) {
+				args = new HashMap<String, Object>();
 			}
-		}
-		
-		final Map defaultArgs;
-		if (oDefaultArgs == null || !(oDefaultArgs instanceof Map)) {
-			defaultArgs = new HashMap<String, Object>();
-		}
-		else {
-			defaultArgs = (Map) oDefaultArgs;
-		}
-		
-		if (bean instanceof groovy.lang.Script) { // create the args binding if not already existing
-			groovy.lang.Script script = (groovy.lang.Script) bean;
-			if (!script.getBinding().hasVariable("defaultArgs")) {
-				script.getBinding().setVariable("defaultArgs", defaultArgs);
+			else {
+				args = (Map) oArgs;
 			}
-		}
-		
-		Log.finest("Calling syncExec on display: " + Display.getDefault());
-		Display.getDefault().syncExec(new Runnable() {
 			
-			@Override
-			public void run() {
-				try {
-					boolean okNames = true;
-					CmdLineParser parser = new CmdLineParser(bean);
-					
-					Display display = Display.getCurrent();
-					Shell shell = display.getActiveShell();
-					Log.finest("Display=" + display + " Shell=" + shell);
-					// check names
-					Class c = bean.getClass();
-					Log.finest("Parsing options: " + parser.getOptions());
-					for (OptionHandler opt : parser.getOptions()) { // pre set variable using the defaultArgs binding
-						try {
-							if (opt.option instanceof NamedOptionDef) {
-								NamedOptionDef option = (NamedOptionDef) opt.option;
-								c.getDeclaredField(option.name());
-								if (defaultArgs.containsKey(option.name())) {
-									option.def = ""+defaultArgs.get(option.name());
+			if (bean instanceof groovy.lang.Script) { // create the args binding if not already existing
+				groovy.lang.Script script = (groovy.lang.Script) bean;
+				if (!script.getBinding().hasVariable("args")) {
+					script.getBinding().setVariable("args", args);
+				}
+			}
+			
+			final Map defaultArgs;
+			if (oDefaultArgs == null || !(oDefaultArgs instanceof Map)) {
+				defaultArgs = new HashMap<String, Object>();
+			}
+			else {
+				defaultArgs = (Map) oDefaultArgs;
+			}
+			
+			if (bean instanceof groovy.lang.Script) { // create the args binding if not already existing
+				groovy.lang.Script script = (groovy.lang.Script) bean;
+				if (!script.getBinding().hasVariable("defaultArgs")) {
+					script.getBinding().setVariable("defaultArgs", defaultArgs);
+				}
+			}
+			
+			Log.finest("Calling syncExec on display: " + Display.getDefault());
+			Display.getDefault().syncExec(new Runnable() {
+				
+				@Override
+				public void run() {
+					try {
+						boolean okNames = true;
+						CmdLineParser parser = new CmdLineParser(bean);
+						
+						Display display = Display.getCurrent();
+						Shell shell = display.getActiveShell();
+						Log.finest("Display=" + display + " Shell=" + shell);
+						// check names
+						Class c = bean.getClass();
+						Log.finest("Parsing options: " + parser.getOptions());
+						for (OptionHandler opt : parser.getOptions()) { // pre set variable using the defaultArgs binding
+							try {
+								if (opt.option instanceof NamedOptionDef) {
+									NamedOptionDef option = (NamedOptionDef) opt.option;
+									c.getDeclaredField(option.name());
+									if (defaultArgs.containsKey(option.name())) {
+										option.def = ""+defaultArgs.get(option.name());
+									}
 								}
 							}
+							catch (NoSuchFieldException e) {
+								Log.warning(TXMUIMessages.errorInAtOptionNameDeclarationColon + e.getMessage());
+								okNames = false;
+							}
 						}
-						catch (NoSuchFieldException e) {
-							Log.warning(TXMUIMessages.errorInAtOptionNameDeclarationColon + e.getMessage());
-							okNames = false;
-						}
-					}
-					if (okNames) {
-						ParametersDialog dialog = new ParametersDialog(shell, bean, parser.getOptions(), args, defaultArgs);
-						if (dialog.getShell() != null) {
-							Log.finest("Activating shell:" + shell);
-							shell.setActive();
-						}
-						
-						ArrayList missingParameters = dialog.getParametersToSet();
-						ArrayList missingMandatoryParameters = dialog.getMandatoryParametersToSet();
-						
-						dialog.initializeMacroVariables(); // with args
-						if (missingParameters.size() > 0) {
-							Log.finer("The parameters dialog must be opened to fill parameters " + missingParameters + " and all mandatory fields: " + missingMandatoryParameters);
-							retOpen = dialog.open() == ParametersDialog.OK;
-							errorOpen = dialog.isError();
-						}
-						else { // fields initialized by 'args'
-							Log.finest("The parameters dialog dont need to be opened all mandatory fields are set: " + args);
-							if (dialog.getNumberOfFields() > 0) dialog.saveParameters();
-							retOpen = true;
-							errorOpen = false;
-						}
-						
-						if (bean instanceof groovy.lang.Script) { // reset the timer binding if already existing
+						if (okNames) {
+							ParametersDialog dialog = new ParametersDialog(shell, bean, parser.getOptions(), args, defaultArgs);
+							if (dialog.getShell() != null) {
+								Log.finest("Activating shell:" + shell);
+								shell.setActive();
+							}
 							
-							groovy.lang.Script script = (groovy.lang.Script) bean;
-							if (script.getBinding().hasVariable("timer")) {
-								Log.finest("Reset groovy execution timer: " + args);
-								Timer timer = (Timer) script.getBinding().getVariable("timer");
-								timer.reset();
+							ArrayList missingParameters = dialog.getParametersToSet();
+							ArrayList missingMandatoryParameters = dialog.getMandatoryParametersToSet();
+							
+							dialog.initializeMacroVariables(); // with args
+							if (missingParameters.size() > 0) {
+								Log.finer("The parameters dialog must be opened to fill parameters " + missingParameters + " and all mandatory fields: " + missingMandatoryParameters);
+								retOpen = dialog.open() == ParametersDialog.OK;
+								errorOpen = dialog.isError();
 							}
+							else { // fields initialized by 'args'
+								Log.finest("The parameters dialog dont need to be opened all mandatory fields are set: " + args);
+								if (dialog.getNumberOfFields() > 0) dialog.saveParameters();
+								retOpen = true;
+								errorOpen = false;
+							}
+							
+							if (bean instanceof groovy.lang.Script) { // reset the timer binding if already existing
+								
+								groovy.lang.Script script = (groovy.lang.Script) bean;
+								if (script.getBinding().hasVariable("timer")) {
+									Log.finest("Reset groovy execution timer: " + args);
+									Timer timer = (Timer) script.getBinding().getVariable("timer");
+									timer.reset();
+								}
+							}
 						}
 					}
+					catch (Throwable e) {
+						Log.severe("Could not open the parameter dialog: " + e);
+						Log.printStackTrace(e);
+						errorOpen = true;
+					}
 				}
-				catch (Throwable e) {
-					Log.severe("Could not open the parameter dialog: " + e);
-					Log.printStackTrace(e);
-					errorOpen = true;
-				}
-			}
-		});
+			});
+			
+		} catch (Throwable e) {
+			Log.severe("Could not open the parameter dialog: " + e);
+			Log.printStackTrace(e);
+			errorOpen = true;
+		}
+		
 		return retOpen && !errorOpen;
 	}
 	
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/scripts/ExecuteGroovyScript.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/scripts/ExecuteGroovyScript.java	(revision 3554)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/scripts/ExecuteGroovyScript.java	(revision 3555)
@@ -282,7 +282,7 @@
 					}
 				} catch (Exception e) {
 					Log.severe(TXMUIMessages.errorDuringScriptExecutionColon+e);
-					org.txm.utils.logger.Log.printStackTrace(e);
+					e.printStackTrace();
 				} finally {
 					monitor.done();			
 				}
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/DebugPreferencePage.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/DebugPreferencePage.java	(revision 3554)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/DebugPreferencePage.java	(revision 3555)
@@ -14,27 +14,34 @@
  *
  */
 public class DebugPreferencePage extends TXMPreferencePage {
-
-
+	
+	
 	@Override
 	public void createFieldEditors() {
+		
 		// Show all result nodes in Corpora view
 		addField(new BooleanFieldEditor(TBXPreferences.SHOW_ALL_RESULT_NODES, TXMUIMessages.showAllResultNodesInCorporaView, getFieldEditorParent()));
+		// change TXM update site base URL
 		addField(new StringFieldEditor(TBXPreferences.UPDATESITE, TXMUIMessages.UpdateSiteAddress, getFieldEditorParent()));
+		// enable some Eclipse features deactivated for TXM
+		addField(new BooleanFieldEditor(TBXPreferences.EXPERT_USER, "Expert mode", getFieldEditorParent()));
 	}
 	
 	
 	@Override
 	public void init(IWorkbench workbench) {
+		
 		this.setPreferenceStore(new TXMPreferenceStore(TBXPreferences.getInstance().getPreferencesNodeQualifier()));
 	}
 	
 	@Override
 	public boolean performOk() {
-		if(super.performOk())	{
+		
+		if (super.performOk()) {
 			CorporaView.refresh();
 			return true;
-		};
+		}
+		;
 		return false;
 	}
-}
\ No newline at end of file
+}
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/RCPPreferences.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/RCPPreferences.java	(revision 3554)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/RCPPreferences.java	(revision 3555)
@@ -102,7 +102,7 @@
 		preferences.putBoolean(CGU, false);
 		
 		preferences.putInt(NO_SESSION, 1);
-		preferences.putInt(MAX_NUMBER_OF_COLUMNS, 100);
+		preferences.putInt(MAX_NUMBER_OF_COLUMNS, 50);
 	}
 	
 	/**
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 3554)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 3555)
@@ -5,6 +5,7 @@
 
 import java.lang.reflect.Field;
 import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.HashSet;
 import java.util.LinkedHashMap;
 import java.util.List;
@@ -1518,6 +1519,17 @@
 				continue;
 			}
 			
+			Field targetField = BeanParameters.getField(getResult(), key);
+			
+//			Field targetField = null;
+//			for (Field f2 : this.getResult().getClass().getFields()) {
+//				Parameter a = f2.getAnnotation(Parameter.class);
+//				if (a != null && a.key().equals(parameter.key())) {
+//					targetField = f2;
+//					break;
+//				}
+//			}
+			
 			try {
 				f.setAccessible(true);
 				Object object = f.get(this);
@@ -1600,7 +1612,23 @@
 					value = ((NewNavigationWidget) object).getCurrentPosition();
 				}
 				else if (object instanceof Combo) {
-					value = ((Combo) object).getText();
+					String s = ((Combo) object).getText();
+					Class<?> clazz = targetField.getType();
+					if (clazz.equals(String.class)) {
+						value = s;
+					} else if (clazz.equals(List.class)) {
+						if (!s.isEmpty()) {
+							value = new ArrayList<>(Arrays.asList(s.split(",")));
+						} else {
+							value = new ArrayList<>();
+						}
+					}
+					
+//					else if (value instanceof List) {
+//						if (!s.isEmpty()) {
+//							value = new ArrayList<>(Arrays.asList(s.split(",")));
+//						}
+//					}
 				}
 				else {
 					value = object;
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/ITXMResultEditor.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/ITXMResultEditor.java	(revision 3554)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/ITXMResultEditor.java	(revision 3555)
@@ -47,7 +47,7 @@
 	
 	public void removeLinkedEditor(ITXMResultEditor<TXMResult> editor);
 	
-	public void addLinkedEditor(ITXMResultEditor<T> editor);
+	public void addLinkedEditor(ITXMResultEditor<TXMResult> editor);
 	
 	public <E extends ITXMResultEditor<TXMResult>> E getLinkedEditor(Class<E> editorClass);
 	
